config/routes.rb
PolkuRoler::Engine.routes.draw do
  root to: 'roles#index'
  post 'toggle_role', to: 'roles#toggle_role'
  post 'new_user', to: 'roles#new_user'

end

app/models/polku_roler/application_record.rb
module PolkuRoler
  class ApplicationRecord < ActiveRecord::Base
    self.abstract_class = true
  end
end

app/models/polku_roler/user.rb
module PolkuRoler
  class User
    include ActiveModel::Model

    attr_accessor :id, :name, :roles, :email

    def self.get_users
      users = dummy_users
      p users
      users.map do |user|
        user = user.stringify_keys
        User.new(id: user['id'], name: user['full_name'], roles: user['roles'], email: user['email'])
      end
    end

    def self.dummy_users
      [{"id":"c2b4a887-5d54-4dbb-a5cf-8068f287a899","username":nil,"full_name":"kantaree lievetmursu","phone":"","email":"kantareeli@comille.fi","tag_ids":[],"roles":"admin, member, special","tags":[],"events":[],"data_blocks":[]},
       {"id":"bd4f4e57-162a-4f1b-8ae0-7f7592ae9af6","username":nil,"full_name":"kan","phone":"","email":"kan@robot.com","tag_ids":[],"roles":"admin, member","tags":[],"events":[],"data_blocks":[]},
       {"id":"bd4f4e57-162a-4f1b-8ae0-7f7592ae9af5","username":nil,"full_name":"kan2","phone":"","email":"kan2@robot.com","tag_ids":[],"roles":"member","tags":[],"events":[],"data_blocks":[]}]
    end

    def roles_as_array
      roles = []
      return roles if self.roles.nil?

      self.roles.split(',').each{|m| roles << m.strip}
      roles.flatten.uniq
    end
  end
end

app/controllers/polku_roler/application_controller.rb
module PolkuRoler
  class ApplicationController < ActionController::Base
    protect_from_forgery with: :exception
    # layout 'layouts/application'
    #
  end
end

app/controllers/polku_roler/roles_controller.rb
require_dependency "polku_roler/application_controller"

module PolkuRoler
  class RolesController < ApplicationController
    #skip_before_action :verify_authenticity_token

    def index
      @notice = params[:notice]
      if !session[:token]
        logout
        redirect_to '/auth/comille', notice: 'Login session is expired, please login again'
      elsif !current_user_admin?
        @notice = 'Only for admins'
      else
        api_request = auth_api_service.get_users
        @api_status = api_request.status
        if @api_status == 401
          logout
          redirect_to '/auth/comille', notice: 'Login session is expired, please login again'
        end
        api_result = api_request.body
        @users = []
        @roles = []
        unless api_result["data"].nil?
          @users = api_result["data"].map do |user|
            user = user["attributes"].stringify_keys
            @roles |= user['roles'].split(',').each(&:strip) unless user['roles'].nil?
            User.new(id: user['id'], name: user['full_name'], roles: user['roles'], email: user['email'])
          end
          @users.sort_by!(&:id)
          @roles.sort!
        end
      end
    end

    def logout
      session.delete(:current_user)
      session.delete(:token)
      session.delete(:token_expires_at)
      session.delete(:refresh_token)
    end

    def get_user_token
      @token ||= session[:token]
    end

    def current_user_admin?
      token = get_user_token
      if token.nil?
        return false
      end
      jwt = JWT.decode(token, OpenSSL::PKey::RSA.new(Rails.application.credentials.jwt_public_key), true, {algorithm: 'RS256'})
      if jwt.empty?
        return false
        end
      if jwt[0]&.try(:[], 'user').try(:[], 'business_roles')&.include?('admin')
        return true
      end
      false
    end

    def new_user
      puts "Invite user, params: #{params}"
      resp = auth_api_service.invite_user(
          get_user_token,
          '',
          params[:email],
          params[:email].split('@')[0],
          params[:roles],
          ''
      )
      Rails.logger.info "api result:  #{resp}"
      notice = status_message(resp, "Invite user: #{params[:email]} failed ")
      redirect_to action: 'index', notice: notice

    end

    def auth_api_service
      @user_api ||= UserApi.new({token: get_user_token})
    end

    def status_message(response, prefix)
      begin
        if !response.status.to_i.between?(200, 399)
          prefix + Net::HTTPResponse::CODE_TO_OBJ[r.status.to_s].to_s
        else
          ''
        end
      rescue Exception
        ''
      end
    end

    def toggle_role
      Rails.logger.info "toggle_role #{params[:user_id]}, #{params[:role]}, #{params[:method]}"
      user_id = params[:user_id]
      role = params[:role]
      method = params[:method] # remove / add
      roles = params[:roles]
      if user_id.present? && role.present?
        current_roles = roles.present? ? roles.split(',').map!(&:strip) : []
        p current_roles
        if method == 'remove'
          current_roles.delete(role)
          roles = current_roles
        else
          roles = current_roles | [role]
        end
        roles.map!(&:strip)
        update_role_params = { roles: roles.join(',') }
        api_request = auth_api_service.update_user(user_id, update_role_params)
      end

      notice = status_message(api_request, "Request #{method} role: #{role}, at user: #{user_id} failed ")
      redirect_to action: 'index', notice: notice
    end
  end
end

app/helpers/polku_roler/application_helper.rb
module PolkuRoler
  module ApplicationHelper
  end
end

app/helpers/polku_roler/roles_helper.rb
module PolkuRoler
  module RolesHelper
  end
end

app/views/layouts/polku_roler/application.html.erb
<!DOCTYPE html>
<html>
<head>
  <title>Polku roler</title>
  <%= csrf_meta_tags %>
  <%= csp_meta_tag %>

  <%= stylesheet_link_tag    "polku_roler/application", media: "all" %>


</head>
<body>

<%= yield %>

</body>
<%= javascript_include_tag "polku_roler/application" %>
</html>

app/views/polku_roler/roles/_status.html.slim
- if  @notice.present?
  p.red "#{@notice}"

app/views/polku_roler/roles/index.html.slim
h2.header-font Users Management
= link_to 'Back', main_app.root_path
.status_partial
  = render "status",  api_status: @api_status
- if @api_status == 200
  table.styled-table
    thead
      tr
        th Id
        th Name
        th Email
        th Roles
        th

    tbody
      - @users.each do |user|
        tr

          td = user.id
          td
            = user.name
          td
            = user.email
          td
            .inline_group
              - @roles.map(&:strip).each do |role|
                .inline_button
                  = button_to role, toggle_role_path(user_id: user.id, role: role, method: "#{user.roles_as_array.include?(role) ? 'remove' : 'add'}", roles: user.roles ), remote: true, method: :post, class: 'button7 ', style: "background-color:#{user.roles_as_array.include?(role) ? '#2979FF' : '#868a89'}", title: "Click to #{user.roles_as_array.include?(role) ? 'remove' : 'add'} role"
          td
            = form_tag toggle_role_path, method: :post, remote: true, authenticity_token: true
              = hidden_field_tag :user_id, user.id
              = hidden_field_tag :roles, user.roles
              = hidden_field_tag :method, 'add'
              = text_field_tag :role
              = submit_tag "Add role", class: 'button7 green-bg'
      tr
        td colspan="5" align="right"
          = form_tag new_user_path, method: :post, remote: true, authenticity_token: true
            = label_tag 'Roles: '
            = text_field_tag :roles, "admin, member", size: 50
            = label_tag ' Email: '
            = text_field_tag :email, nil, :placeholder => 'name@email.com', size: 60
            = submit_tag "+ Add new user", class: 'button7 green-bg'

- else
  p.red "Get users error: #{@api_status} #{Net::HTTPResponse::CODE_TO_OBJ[@api_status.to_s].to_s}"